__author__ = 'Martin'

# this function should return True if x is in the set of numbers but only if x is not equal to y
# otherwise it should return False
def exclusive_in(x, numbers, y):
    return x in numbers and x is not y
print()
numbers = {1, 16, 42, 101, 10249561} # {} brackets define a set
a = 10249561
c = 10249561
print(exclusive_in(a, numbers, c))
# output: False as it should be

c = int(10249561.0)
print('\nthe real 10249561.0 has been cast to an integer:', type(c) is int)
print(exclusive_in(a, numbers, c))
# output: True as it shouldn't be

# we can assume this discrepancy occurs because Python caches integers
# the first c is the same 10249561 as a's 10249561
# because of its circuitous provenance the second c is a new and different 10249561

def better_exclusive_in(x, numbers, y):
    return x != y and x in numbers

print()
print(better_exclusive_in(a, numbers, c))
# output: False as it should be

print('------------------')
p = 0; q = 1; r = 1; s = 0
print(p < q ^ r < s)
print((p < q) ^ (r < s))


def foo():
    print('foo')
    return 1
def bar():
    print('bar')
    return 2
def bal(a, b):
    print('plus')
    return a < 0 and b > 0

print(bal(foo(),bar()))

def got_a_lot_done():
    print('got_a_lot_done()')
    return True

print('\nimplication')
def happy_2(workday):
    if workday:
        return got_a_lot_done()
    else:
        return True

workday = False
v = not workday or workday and got_a_lot_done()
workday = True
v = not workday or workday and got_a_lot_done()

sequence = [2, 3, 5, 7, 11, 13]
index = 0
required_value = 11
length_sequence = len(sequence)
while index < length_sequence and sequence[index] != required_value:
    index += 1
print(index)

print('------------\n')


def low_score():
    print('low score actions')
    return False

def mid_score():
    print('mid score actions')
    return True

def high_score():
    print('high score actions')
    return False

def imp(A, B):
    # print(A, 'implies', B)
    if A: return B()
    return True

def test_score(score):
    print('score', score)
    evaluation = imp(score < 40, low_score) and \
                 imp(40 <= score <= 85, mid_score) and \
                 imp(75 <= score <= 100, high_score)
    return evaluation

print(test_score(39),'\n')
print(test_score(50),'\n')
print(test_score(80),'\n')

print('-----------------')

def test_score1(score):
    evaluation = False
    if score < 40:
        evaluation = low_score()
    else:
        if 40 <= score <= 85:
            evaluation = mid_score()
        if 75 <= score <= 100:
            evaluation = high_score()
    return evaluation

print(test_score1(39),'\n')
print(test_score1(50),'\n')
print(test_score1(80),'\n')

def odd(n):
    return bool(n & 1)
def even(n):
     return not(n & 1)
def even2(n):
    return bool(~n & 1)
def even3(n):
    return bool(n & 1 ^ 1)

n = 100
print(n, odd(n), even(n), even2(n), even3(n))

n = 101
print(n, odd(n), even(n), even2(n), even3(n))

print (type(int) is int)

print(-5%4)

print(bool(0.1))

